import React from 'react';
import defaultOptions from '../../defaultOptions';
import { ActionType } from '../../enums';
import { isEmpty } from '../../Utils/CommonUtils';
import { replaceValue } from '../../Utils/DataUtils';
var CellEditorBoolean = function (_a) {
    var column = _a.column, dispatch = _a.dispatch, rowData = _a.rowData, rowKeyField = _a.rowKeyField, value = _a.value;
    return (React.createElement("input", { autoFocus: true, className: defaultOptions.css.checkbox, type: 'checkbox', ref: function (elem) { return elem && (elem.indeterminate = isEmpty(value)); }, checked: value || false, onChange: function (event) { return dispatch(ActionType.ChangeRowData, { newValue: replaceValue(rowData, column, event.currentTarget.checked) }); }, onBlur: function () {
            var cell = { columnKey: column.key, rowKey: rowData[rowKeyField] };
            dispatch(ActionType.CloseEditor, { cell: cell });
        } }));
};
export default CellEditorBoolean;