import React from 'react';
import defaultOptions from '../../defaultOptions';
import { ActionType } from '../../enums';
import { getValueByColumn, replaceValue } from '../../Utils/DataUtils';
import { getDateInputValue } from '../../Utils/DateUtils';
var CellEditorDate = function (_a) {
    var column = _a.column, dispatch = _a.dispatch, rowData = _a.rowData, rowKeyField = _a.rowKeyField;
    var fieldValue = getValueByColumn(rowData, column);
    var value = fieldValue && getDateInputValue(fieldValue);
    return (React.createElement("input", { autoFocus: true, className: defaultOptions.css.dateInput, type: 'date', value: value || '', onChange: function (event) {
            var targetValue = event.currentTarget.value;
            var newValue = targetValue ? new Date(targetValue) : null;
            dispatch(ActionType.ChangeRowData, { newValue: replaceValue(rowData, column, newValue) });
        }, onBlur: function () {
            var cell = { columnKey: column.key, rowKey: rowData[rowKeyField] };
            dispatch(ActionType.CloseEditor, { cell: cell });
        } }));
};
export default CellEditorDate;