import React from 'react';
import defaultOptions from '../../defaultOptions';
import { ActionType } from '../../enums';
import { replaceValue } from '../../Utils/DataUtils';
var CellEditorNumber = function (_a) {
    var column = _a.column, dispatch = _a.dispatch, field = _a.field, rowData = _a.rowData, value = _a.value, rowKeyField = _a.rowKeyField;
    return (React.createElement("input", { autoFocus: true, className: defaultOptions.css.numberInput, type: 'number', value: value === null || value === undefined ? '' : value, onChange: function (event) {
            var newValue = event.currentTarget.value !== '' ? Number(event.currentTarget.value) : null;
            dispatch(ActionType.ChangeRowData, { newValue: replaceValue(rowData, column, newValue) });
        }, onBlur: function () {
            var cell = { columnKey: column.key, rowKey: rowData[rowKeyField] };
            dispatch(ActionType.CloseEditor, { cell: cell });
        } }));
};
export default CellEditorNumber;