import React from 'react';
import defaultOptions from '../../defaultOptions';
import { ActionType } from '../../enums';
import { replaceValue } from '../../Utils/DataUtils';
var CellEditorString = function (_a) {
    var column = _a.column, dispatch = _a.dispatch, rowData = _a.rowData, value = _a.value, rowKeyField = _a.rowKeyField;
    return (React.createElement("input", { autoFocus: true, type: 'text', className: defaultOptions.css.textInput, value: value || '', onChange: function (event) {
            dispatch(ActionType.ChangeRowData, { newValue: replaceValue(rowData, column, event.currentTarget.value) });
        }, onBlur: function () {
            var cell = { columnKey: column.key, rowKey: rowData[rowKeyField] };
            dispatch(ActionType.CloseEditor, { cell: cell });
        } }));
};
export default CellEditorString;