var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import * as React from 'react';
import { ActionType, EditingMode } from '../../enums';
import { isEmpty } from '../../Utils/CommonUtils';
import { extendProps } from '../../Utils/PropsUtils';
var CellText = function (props) {
    var childAttributes = props.childAttributes, column = props.column, format = props.column.format, dispatch = props.dispatch, editingMode = props.editingMode, rowData = props.rowData, rowKeyField = props.rowKeyField, value = props.value;
    var formatedValue = format ? format(value) : !isEmpty(value) && value.toString();
    var componentProps = {
        className: 'ka-cell-text',
        onClick: function () {
            if (editingMode === EditingMode.Cell) {
                var cell = { columnKey: column.key, rowKey: rowData[rowKeyField] };
                dispatch(ActionType.OpenEditor, { cell: cell });
            }
        },
    };
    var divProps = extendProps(componentProps, props, childAttributes.cell, props.dispatch);
    return (React.createElement("div", __assign({}, divProps), formatedValue || React.createElement(React.Fragment, null, "\u00A0")));
};
export default CellText;