var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import React from 'react';
import defaultOptions from '../../defaultOptions';
import DataRowContent from '../DataRowContent/DataRowContent';
import EmptyCells from '../EmptyCells/EmptyCells';
var DataRow = function (props) {
    var groupColumnsCount = props.groupColumnsCount, rowData = props.rowData, rowKeyField = props.rowKeyField, dataRow = props.dataRow, selectedRows = props.selectedRows, trRef = props.trRef;
    var rowKeyValue = rowData[rowKeyField];
    var isSelectedRow = selectedRows.some(function (s) { return s === rowKeyValue; });
    var dataRowProps = __assign(__assign({}, props), { isSelectedRow: isSelectedRow, rowKeyValue: rowKeyValue });
    var dataRowContent = dataRow && dataRow(dataRowProps);
    return (React.createElement("tr", { ref: trRef, className: defaultOptions.css.row + " " + (isSelectedRow ? defaultOptions.css.rowSelected : '') },
        React.createElement(EmptyCells, { count: groupColumnsCount }),
        dataRowContent
            ? React.createElement("td", { className: defaultOptions.css.cell }, dataRowContent)
            : React.createElement(DataRowContent, __assign({}, dataRowProps))));
};
export default DataRow;