import React from 'react';
import defaultOptions from '../../defaultOptions';
import { ActionType } from '../../enums';
import EmptyCells from '../EmptyCells/EmptyCells';
var GroupRowContent = function (props) {
    var column = props.column, contentColSpan = props.contentColSpan, dispatch = props.dispatch, groupIndex = props.groupIndex, groupKey = props.groupKey, isExpanded = props.isExpanded, text = props.text;
    return (React.createElement(React.Fragment, null,
        React.createElement(EmptyCells, { count: groupIndex }),
        React.createElement("td", { className: 'ka-group-column', colSpan: contentColSpan },
            React.createElement("div", { className: 'ka-group-column-content' },
                React.createElement("div", { onClick: function () {
                        dispatch(ActionType.UpdateGroupsExpanded, {
                            groupKey: groupKey,
                        });
                    }, className: isExpanded
                        ? defaultOptions.css.iconGroupArrowExpanded : defaultOptions.css.iconGroupArrowCollapsed }),
                column && column.groupCell ? column.groupCell(props) : React.createElement("div", { className: 'ka-group-text' }, text)))));
};
export default GroupRowContent;