var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import React, { useEffect, useRef } from 'react';
import { getGroupMark, getGroupText } from '../../Utils/GroupUtils';
import DataRow from '../DataRow/DataRow';
import GroupRow from '../GroupRow/GroupRow';
var Rows = function (props) {
    var columns = props.columns, data = props.data, dispatch = props.dispatch, groupedColumns = props.groupedColumns, _a = props.groups, groups = _a === void 0 ? [] : _a, _b = props.groupsExpanded, groupsExpanded = _b === void 0 ? [] : _b, groupRow = props.groupRow, onFirstRowRendered = props.onFirstRowRendered, rowKeyField = props.rowKeyField;
    var groupMark = getGroupMark();
    var firstRowRef = useRef(null);
    useEffect(function () {
        onFirstRowRendered(firstRowRef);
    }, [firstRowRef, onFirstRowRendered]);
    var rowRefLink = firstRowRef;
    return (React.createElement(React.Fragment, null, data.map(function (d) {
        if (d.groupMark === groupMark) {
            var groupIndex = d.key.length - 1;
            var group_1 = groups && groups[groupIndex];
            var column = group_1 && groupedColumns.find(function (c) { return c.key === group_1.columnKey; });
            return (React.createElement(GroupRow, { column: column, contentColSpan: columns.length - groupIndex + groups.length, dispatch: dispatch, groupIndex: groupIndex, groupKey: d.key, groupRow: groupRow, isExpanded: groupsExpanded.some(function (ge) { return JSON.stringify(ge) === JSON.stringify(d.key); }), text: getGroupText(d.value, column), key: d.key }));
        }
        else {
            var dataRow = (React.createElement(DataRow, __assign({}, props, { trRef: rowRefLink, key: d[rowKeyField], rowData: d })));
            rowRefLink = undefined;
            return dataRow;
        }
    })));
};
export default Rows;