var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import * as React from 'react';
import defaultOptions from '../../defaultOptions';
import { EditingMode, FilteringMode, SortingMode } from '../../enums';
import { wrapDispatch } from '../../Utils/ActionUtils';
import { filterData, searchData } from '../../Utils/FilterUtils';
import { getExpandedGroups, getGroupedData } from '../../Utils/GroupUtils';
import { extendProps } from '../../Utils/PropsUtils';
import { sortData } from '../../Utils/SortUtils';
import { convertToColumnTypes } from '../../Utils/TypeUtils';
import FilterRow from '../FilterRow/FilterRow';
import HeadRow from '../HeadRow/HeadRow';
import TableBody from '../TableBody/TableBody';
export var Table = function (props) {
    var _a = props.childAttributes, childAttributes = _a === void 0 ? {} : _a, _b = props.editableCells, editableCells = _b === void 0 ? [] : _b, _c = props.editingMode, editingMode = _c === void 0 ? EditingMode.None : _c, filteringMode = props.filteringMode, groups = props.groups, search = props.search, _d = props.selectedRows, selectedRows = _d === void 0 ? [] : _d, _e = props.sortingMode, sortingMode = _e === void 0 ? SortingMode.None : _e;
    var columns = props.columns, _f = props.data, data = _f === void 0 ? [] : _f;
    data = search ? searchData(columns, data, search) : data;
    data = convertToColumnTypes(data, columns);
    data = filterData(data, columns);
    data = sortData(columns, data);
    var groupColumnsCount = 0;
    var groupedColumns = [];
    if (groups) {
        groupColumnsCount = groups.length;
        groupedColumns = columns.filter(function (c) { return groups.some(function (g) { return g.columnKey === c.key; }); });
        columns = columns.filter(function (c) { return !groups.some(function (g) { return g.columnKey === c.key; }); });
    }
    var groupsExpanded = props.groupsExpanded;
    var groupedData = groups ? getGroupedData(data, groups, groupedColumns, groupsExpanded) : data;
    if (groups && !groupsExpanded) {
        groupsExpanded = getExpandedGroups(groupedData);
    }
    var theadRef = React.useRef(null);
    var dispatch = wrapDispatch(__assign(__assign({}, props), { groupsExpanded: groupsExpanded }), theadRef);
    var componentProps = {
        className: defaultOptions.css.table,
    };
    var tableProps = extendProps(componentProps, props, childAttributes.table, dispatch);
    return (React.createElement("div", { className: 'ka' },
        React.createElement("table", __assign({}, tableProps),
            React.createElement("thead", { className: defaultOptions.css.thead, ref: theadRef },
                React.createElement(HeadRow, { groupColumnsCount: groupColumnsCount, columns: columns, dispatch: dispatch, sortingMode: sortingMode }),
                filteringMode === FilteringMode.FilterRow &&
                    (React.createElement(FilterRow, { columns: columns, dispatch: dispatch, groupColumnsCount: groupColumnsCount }))),
            React.createElement(TableBody, __assign({}, props, { childAttributes: childAttributes, columns: columns, data: groupedData, dispatch: dispatch, editableCells: editableCells, editingMode: editingMode, groupColumnsCount: groupColumnsCount, groupedColumns: groupedColumns, groupsExpanded: groupsExpanded, selectedRows: selectedRows })))));
};